<?php
/**
 
 */

/***
 * Class ProductExtraInfo
 */
class ProductExtraInfo
{
    /**
     * Chargé depuis la base de données
     */
    private $loadedFromDb = false;

    /** @var int Product ID */
    public $id_product;

    /** @var string Birthday (yyyy-mm-dd) */
    public $date_depublication = null;

    /**
     * ProductExtraInfo constructor.
     *
     * @param int|null $id
     * @param bool $initNew nouvel objet renvoyé si non trouvé !
     */
    public static function GetForProduct($id_product, $initNew = true)
    {
        // Charge les informations supplémentaires du produit
        $db = Db::getInstance();
        $extraInfos = $db->executeS("SELECT * FROM "._DB_PREFIX_."polarislink_products WHERE id_product = ".(int)$id_product);
        if ($extraInfos === false)
            throw new \Exception("impossible de charger les informations étendues du produit ".$id_product. " : ".$db->getMsgError());

        if ($extraInfos)
        {
            // On prend que la première ligne
            $extraInfos = $extraInfos[0];

            $obj = new ProductExtraInfo();
            $obj->id_product = $extraInfos['id_product'];
            $obj->loadedFromDb = true;
            $obj->date_depublication = $extraInfos['date_depublication'];
            return $obj;
        }
        else if ($initNew)
        {
            $obj = new ProductExtraInfo();
            $obj->id_product = $id_product;
            return $obj;
        }
        
        return false;
    }

    /**
     * Sauvegarde les informations supplémentaires du produit
     */
    public function save()
    {
        $db = Db::getInstance();

        $result = $db->execute(sprintf(
            'INSERT INTO '._DB_PREFIX_.'polarislink_products (id_product, date_depublication) VALUES (%1$d, %2$s) '.
                'ON DUPLICATE KEY UPDATE date_depublication = %2$s', 
                (int) $this->id_product, 
                $this->date_depublication ? "'".$this->date_depublication."'" : 'NULL',
            ));
        if (!$result)
            throw new PrestaShopDatabaseException($db->getMsgError());                            
    }  
}
