<?php
	/*
	* 2018 - VEGA Informatique
	*
	* NOTICE OF LICENSE
	*
	* This source file is subject to the Open Software License (OSL 3.0)
	* that is bundled with this package in the file LICENSE.txt.
	* It is also available through the world-wide-web at this URL:
	* http://opensource.org/licenses/osl-3.0.php
	*
	* DISCLAIMER
	*
	* Do not edit or add to this file if you wish to upgrade PolarisLink to newer
	* versions in the future. 
	*
	*  @author VEGA Informatique <contact@vega-info.fr>
	*  @copyright  2018 VEGA Informatique
	*  @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
	*/

	if (!defined('_PS_VERSION_'))
		exit;	
		
	function upgrade_module_3_40($module)
	{
		/*
			Création de la base de données
		*/
		$db = Db::getInstance();
	
		try
		{
			// Création de la table de stock
			if (!$db->execute("CREATE TABLE `"._DB_PREFIX_."polarislink_stocks` (
				id_stock INT(10) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
				id_product INT(10) UNSIGNED NOT NULL,
				id_product_attribute INT(10) UNSIGNED,
				id_store INT(10) UNSIGNED NOT NULL,
				stock INT(10) NOT NULL DEFAULT 0,
				date_upd DATETIME NOT NULL
				) ENGINE="._MYSQL_ENGINE_." DEFAULT CHARSET=utf8;")) 
				throw new Exception("impossible de créer la table polarislink_stocks");

			if (!$db->execute("ALTER TABLE `"._DB_PREFIX_."polarislink_stocks` ADD CONSTRAINT `FK_polarislink_stocks_product` FOREIGN KEY (`id_product`) REFERENCES `"._DB_PREFIX_."product` (`id_product`) ON UPDATE CASCADE ON DELETE CASCADE;")) 
				throw new Exception(sprintf("impossible de lier la table %s à %s", "polarislink_stocks", "product"));					
			if (!$db->execute("ALTER TABLE `"._DB_PREFIX_."polarislink_stocks` ADD CONSTRAINT `FK_polarislink_stocks_product_attribute` FOREIGN KEY (`id_product_attribute`) REFERENCES `"._DB_PREFIX_."product_attribute` (`id_product_attribute`) ON UPDATE CASCADE ON DELETE CASCADE;")) 
				throw new Exception(sprintf("impossible de lier la table %s à %s", "polarislink_stocks", "product_attribute"));
			if (!$db->execute("ALTER TABLE `"._DB_PREFIX_."polarislink_stocks` ADD CONSTRAINT `FK_polarislink_stocks_store` FOREIGN KEY (`id_store`) REFERENCES `"._DB_PREFIX_."store` (`id_store`) ON UPDATE CASCADE ON DELETE CASCADE;")) 
				throw new Exception(sprintf("impossible de lier la table %s à %s", "polarislink_stocks", "store"));
			
			if (!$db->execute("ALTER TABLE `"._DB_PREFIX_."polarislink_stocks` ADD UNIQUE `PK_polarislink_stocks` (`id_product`, `id_product_attribute`, `id_store`) USING BTREE;")) 
				throw new Exception(sprintf("impossible de créer la restriction unique de la table %s", "polarislink_stocks"));

			// Modification de la table commande
			/*
			if (!$db->execute("ALTER TABLE `"._DB_PREFIX_."orders` ADD COLUMN IF NOT EXISTS id_store INT(10) UNSIGNED")) 
				throw new Exception("impossible d'ajouter la colonne store_id à la table 'orders'");

			if (!$db->execute("ALTER TABLE `"._DB_PREFIX_."orders` ADD CONSTRAINT `FK_polarislink_orders_store` FOREIGN KEY (`id_store`) REFERENCES `"._DB_PREFIX_."store` (`id_store`) ON UPDATE CASCADE ON DELETE SET NULL;")) 
				throw new Exception(sprintf("impossible de lier la table %s à %s", "orders", "store"));
			*/
			$module->registerHooks();
		}
		catch (Exception $ex)
		{
			$module->install_error(Tools::displayError($ex));			
			return false;
		}
				
		return true;
	 }
 